#!/bin/sh
# convert a OFX file to a CSV file containing stock purchases

if [ ! -f "$1" ] ; then
    echo "usage: ofx2csv.sh <OFX filename>"
    exit 1
fi

STEM=$(basename "$1" .ofx)

TMP=/tmp/$$.ofx

echo '<!DOCTYPE OFX SYSTEM "ofxmain.dtd" >' > $TMP
#echo '<!ENTITY amp "&">' >> $TMP
perl -ne '$a=1 if /<OFX>/;print if $a;' "$1" >> $TMP

XML="${STEM}.xml"
osx -D OFX/OFX-1.0.3/ $TMP > "$XML"
rm $TMP

CSV="${STEM}.csv"
xsltproc ofx_xml2csv.xslt "$XML" | perl -ne 'next if /^\s+$/;print' > "$CSV"
rm "$XML"

echo "created $CSV"
exit 0
